/*!
 * Copyright (c) 2012 - 2023, Anaconda, Inc., and Bokeh Contributors
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 * 
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * 
 * Redistributions in binary form must reproduce the above copyright notice,
 * this list of conditions and the following disclaimer in the documentation
 * and/or other materials provided with the distribution.
 * 
 * Neither the name of Anaconda nor the names of any contributors
 * may be used to endorse or promote products derived from this software
 * without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */
(function(root, factory) {
  factory(root["Bokeh"], undefined);
})(this, function(Bokeh, version) {
  let define;
  return (function(modules, entry, aliases, externals) {
    const bokeh = typeof Bokeh !== "undefined" && (version != null ? Bokeh[version] : Bokeh);
    if (bokeh != null) {
      return bokeh.register_plugin(modules, entry, aliases);
    } else {
      throw new Error("Cannot find Bokeh " + version + ". You have to load it prior to loading plugins.");
    }
  })
({
"5cc578079d": function _(e,o,s,r,a){r();const l=e("3806528878");(0,e("@bokehjs/base").register_models)({MeasureTool:l.MeasureTool})},
"3806528878": function _(e,t,s,n,i){var a,l;n();const o=e("tslib"),_=e("@bokehjs/models/annotations/annotation"),r=o.__importStar(e("@bokehjs/core/property_mixins")),d=e("@bokehjs/models/tools/edit/edit_tool"),c=e("@bokehjs/models/annotations/label");class h extends _.AnnotationView{connect_signals(){super.connect_signals(),this.connect(this.model.change,(()=>this.plot_view.request_paint(this)))}_render(){if(!this.model.visible)return;const{ctx:e}=this.layer;e.save(),e.beginPath(),this.visuals.line.set_value(e),e.moveTo(this.model.x_start,this.model.y_start),e.lineTo(this.model.x_end,this.model.y_end),e.stroke(),e.restore()}}s.LineMeasureView=h,h.__name__="LineMeasureView";class u extends _.Annotation{constructor(e){super(e)}}s.LineMeasure=u,a=u,u.__name__="LineMeasure",a.prototype.default_view=h,a.mixins(r.Line),a.define((({Number:e})=>({x_start:[e,0],x_end:[e,0],y_start:[e,0],y_end:[e,0]})));class m extends d.EditToolView{connect_signals(){super.connect_signals(),this.connect(this.model.properties.active.change,(()=>this._active_change()))}_active_change(){this.model.active||this._reset_measure_band()}_reset_measure_band(){this.model.measure_band.scale.x_start=0,this.model.measure_band.scale.y_start=0,this.model.measure_band.scale.x_end=0,this.model.measure_band.scale.y_end=0,this.model.measure_band.label.text="",this.model.measure_band.pos_label.text=""}}s.MeasureToolView=m,m.__name__="MeasureToolView";class b extends d.EditTool{constructor(e){super(e),this.default_order=12,this.event_type=["tap","pan","move","scroll"]}initialize(){super.initialize(),this.measure_band={scale:new u({x_start:0,y_start:0,x_end:0,y_end:0,line_dash:this.line_dash,line_color:this.line_color,line_width:this.line_width,line_alpha:this.line_alpha}),label:new c.Label({x:10,y:35,x_units:"screen",y_units:"screen",text:"",text_font_size:"18px",background_fill_alpha:.75,background_fill_color:"white"}),pos_label:new c.Label({x:10,y:10,x_units:"screen",y_units:"screen",text:"",text_font_size:"18px",background_fill_alpha:.75,background_fill_color:"white"})}}}s.MeasureTool=b,l=b,b.__name__="MeasureTool",l.prototype.default_view=m,l.define((({Number:e,String:t,Array:s,Color:n})=>({measure_unit:[t,""],line_dash:[s(e),[4,4]],line_color:[n,"black"],line_width:[e,1.5],line_alpha:[e,1]})))},
}, "5cc578079d", {"index":"5cc578079d","measuretool":"3806528878"}, {});});
